package ro.cs.pub.pubsub.overlay;

import ro.cs.pub.pubsub.message.MessageContent;
import ro.cs.pub.pubsub.overlay.view.View;

public class OverlayMessage implements MessageContent {
	private static final long serialVersionUID = 1L;

	/**
	 * The overlay's id.
	 */
	private final OverlayId overlayId;

	/**
	 * View generated by the sending agent.
	 */
	private final View view;

	/**
	 * The type of message.
	 */
	private final boolean reply;

	public OverlayMessage(OverlayId overlayId, View view, boolean reply) {
		this.overlayId = overlayId;
		this.view = view;
		this.reply = reply;
	}

	public OverlayId getOverlayId() {
		return overlayId;
	}

	public View getView() {
		return view;
	}

	public boolean isReply() {
		return reply;
	}

	@Override
	public String toString() {
		return "OverlayMessage [overlayId=" + overlayId + ", reply=" + reply
				+ ", view=" + view + "]";
	}
}
